use crate::DbPool;
use crate::api::ClientVersion;
use crate::providers::Provider;
use crate::status::*;
use crate::util::cache::VideoCache;
use crate::util::parse_abbreviated_number;
use crate::util::time::parse_time_to_seconds;
use crate::videos::{ServerOptions, VideoItem};
use async_trait::async_trait;
use error_chain::error_chain;
use htmlentity::entity::{ICodedDataTrait, decode};
use std::vec;

pub const CHANNEL_METADATA: crate::providers::ProviderChannelMetadata =
    crate::providers::ProviderChannelMetadata {
        group_id: "mainstream-tube",
        tags: &["tube", "hd", "mixed"],
    };

error_chain! {
    foreign_links {
        Io(std::io::Error);
        HttpRequest(wreq::Error);
    }
}

#[derive(Debug, Clone)]
pub struct PornhatProvider {
    url: String,
}
impl PornhatProvider {
    pub fn new() -> Self {
        PornhatProvider {
            url: "https://www.pornhat.com".to_string(),
        }
    }

    fn build_channel(&self, _clientversion: ClientVersion) -> Channel {
        Channel {
            id: "pornhat".to_string(),
            name: "Pornhat".to_string(),
            description: "free HD porn videos".to_string(),
            premium: false,
            favicon: "https://www.google.com/s2/favicons?sz=64&domain=pornhat.com".to_string(),
            status: "active".to_string(),
            categories: vec![],
            options: vec![ChannelOption {
                id: "sort".to_string(),
                title: "Sort".to_string(),
                description: "Sort the Videos".to_string(),
                systemImage: "list.number".to_string(),
                colorName: "blue".to_string(),
                options: vec![
                    FilterOption {
                        id: "new".to_string(),
                        title: "New".to_string(),
                    },
                    FilterOption {
                        id: "popular".to_string(),
                        title: "Popular".to_string(),
                    },
                    FilterOption {
                        id: "trending".to_string(),
                        title: "Trending".to_string(),
                    },
                ],
                multiSelect: false,
            }],
            nsfw: true,
            cacheDuration: Some(1800),
        }
    }
    async fn get(
        &self,
        cache: VideoCache,
        page: u8,
        sort: &str,
        options: ServerOptions,
    ) -> Result<Vec<VideoItem>> {
        let sort_string = match sort {
            "trending" => "/trending",
            "popular" => "/popular",
            _ => "",
        };
        let video_url = format!("{}{}/{}/", self.url, sort_string, page);
        let old_items = match cache.get(&video_url) {
            Some((time, items)) => {
                if time.elapsed().unwrap_or_default().as_secs() < 60 * 5 {
                    return Ok(items.clone());
                } else {
                    items.clone()
                }
            }
            None => {
                vec![]
            }
        };
        let mut requester =
            crate::providers::requester_or_default(&options, module_path!(), "missing_requester");
        let text = match requester.get(&video_url, None).await {
            Ok(text) => text,
            Err(e) => {
                crate::providers::report_provider_error(
                    "pornhat",
                    "get.request",
                    &format!("url={video_url}; error={e}"),
                )
                .await;
                return Ok(old_items);
            }
        };
        let video_items: Vec<VideoItem> = self.get_video_items_from_html(text.clone());
        if !video_items.is_empty() {
            cache.remove(&video_url);
            cache.insert(video_url.clone(), video_items.clone());
        } else {
            return Ok(old_items);
        }
        Ok(video_items)
    }
    async fn query(
        &self,
        cache: VideoCache,
        page: u8,
        query: &str,
        options: ServerOptions,
    ) -> Result<Vec<VideoItem>> {
        let search_string = query.to_lowercase().trim().replace(" ", "-");
        let mut video_url = format!("{}/search/{}/{}/", self.url, search_string, page);

        if search_string.starts_with("@") {
            let url_part = search_string
                .split("@")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .replace(":", "/");
            video_url = format!("{}/{}/", self.url, url_part);
        }
        // Check our Video Cache. If the result is younger than 1 hour, we return it.
        let old_items = match cache.get(&video_url) {
            Some((time, items)) => {
                if time.elapsed().unwrap_or_default().as_secs() < 60 * 5 {
                    return Ok(items.clone());
                } else {
                    let _ = cache.check().await;
                    return Ok(items.clone());
                }
            }
            None => {
                vec![]
            }
        };
        let mut requester =
            crate::providers::requester_or_default(&options, module_path!(), "missing_requester");
        let text = match requester.get(&video_url, None).await {
            Ok(text) => text,
            Err(e) => {
                crate::providers::report_provider_error(
                    "pornhat",
                    "query.request",
                    &format!("url={video_url}; error={e}"),
                )
                .await;
                return Ok(old_items);
            }
        };
        let video_items: Vec<VideoItem> = self.get_video_items_from_html(text.clone());
        if !video_items.is_empty() {
            cache.remove(&video_url);
            cache.insert(video_url.clone(), video_items.clone());
        } else {
            return Ok(old_items);
        }
        Ok(video_items)
    }

    fn get_video_items_from_html(&self, html: String) -> Vec<VideoItem> {
        if html.is_empty() {
            println!("HTML is empty");
            return vec![];
        }
        let mut items: Vec<VideoItem> = Vec::new();
        let raw_videos = html
            .split("<div class=\"pagination\"")
            .collect::<Vec<&str>>()
            .get(0)
            .copied()
            .unwrap_or_default()
            .split("item thumb-bl thumb-bl-video video_")
            .collect::<Vec<&str>>()[1..]
            .to_vec();
        for video_segment in &raw_videos {
            // let vid = video_segment.split("\n").collect::<Vec<&str>>();
            // for (index, line) in vid.iter().enumerate() {
            //     println!("Line {}: {}", index, line);
            // }
            let video_url: String = format!(
                "{}{}",
                self.url,
                video_segment
                    .split("<a href=\"")
                    .collect::<Vec<&str>>()
                    .get(1)
                    .copied()
                    .unwrap_or_default()
                    .split("\"")
                    .collect::<Vec<&str>>()
                    .get(0)
                    .copied()
                    .unwrap_or_default()
            );
            let preview_url = video_segment
                .split("data-preview-custom=\"")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("\"")
                .collect::<Vec<&str>>()
                .get(0)
                .copied()
                .unwrap_or_default()
                .to_string();
            let mut title = video_segment
                .split("\" title=\"")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("\"")
                .collect::<Vec<&str>>()
                .get(0)
                .copied()
                .unwrap_or_default()
                .to_string();
            // html decode
            title = decode(title.as_bytes()).to_string().unwrap_or(title);
            let id = video_url
                .split("/")
                .collect::<Vec<&str>>()
                .get(4)
                .copied()
                .unwrap_or_default()
                .to_string();
            let raw_duration = video_segment
                .split("fa fa-clock-o")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("<span>")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("<")
                .collect::<Vec<&str>>()
                .get(0)
                .copied()
                .unwrap_or_default()
                .to_string();
            let duration = parse_time_to_seconds(&raw_duration).unwrap_or(0) as u32;

            let thumb = video_segment
                .split("<img class=\"thumb lazy-load\"")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("data-original=\"")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("\"")
                .collect::<Vec<&str>>()
                .get(0)
                .copied()
                .unwrap_or_default()
                .to_string();

            let mut tags = vec![];
            if video_segment.contains("href=\"/sites/") {
                let raw_tags = video_segment.split("href=\"/sites/").collect::<Vec<&str>>()[1..]
                    .iter()
                    .map(|s| {
                        s.split("/\"")
                            .collect::<Vec<&str>>()
                            .get(0)
                            .copied()
                            .unwrap_or_default()
                            .to_string()
                    })
                    .collect::<Vec<String>>();
                for tag in raw_tags {
                    if !tag.is_empty() {
                        tags.push(format!("@sites:{}", tag));
                    }
                }
            }
            if video_segment.contains("href=\"/models/") {
                let raw_tags = video_segment
                    .split("href=\"/models/")
                    .collect::<Vec<&str>>()[1..]
                    .iter()
                    .map(|s| {
                        s.split("/\"")
                            .collect::<Vec<&str>>()
                            .get(0)
                            .copied()
                            .unwrap_or_default()
                            .to_string()
                    })
                    .collect::<Vec<String>>();
                for tag in raw_tags {
                    if !tag.is_empty() {
                        tags.push(format!("@models:{}", tag));
                    }
                }
            }

            let views_part = video_segment
                .split("fa fa-eye")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("<span>")
                .collect::<Vec<&str>>()
                .get(1)
                .copied()
                .unwrap_or_default()
                .split("<")
                .collect::<Vec<&str>>()
                .get(0)
                .copied()
                .unwrap_or_default()
                .to_string();
            let views = parse_abbreviated_number(&views_part).unwrap_or(0) as u32;

            let video_item = VideoItem::new(
                id,
                title,
                video_url.to_string(),
                "Pornhat".to_string(),
                thumb,
                duration,
            )
            .preview(preview_url)
            .views(views)
            .tags(tags);
            items.push(video_item);
        }
        return items;
    }
}

#[async_trait]
impl Provider for PornhatProvider {
    async fn get_videos(
        &self,
        cache: VideoCache,
        pool: DbPool,
        sort: String,
        query: Option<String>,
        page: String,
        per_page: String,
        options: ServerOptions,
    ) -> Vec<VideoItem> {
        let _ = per_page;
        let _ = pool;
        let videos: std::result::Result<Vec<VideoItem>, Error> = match query {
            Some(q) => {
                self.query(cache, page.parse::<u8>().unwrap_or(1), &q, options)
                    .await
            }
            None => {
                self.get(cache, page.parse::<u8>().unwrap_or(1), &sort, options)
                    .await
            }
        };
        match videos {
            Ok(v) => v,
            Err(e) => {
                println!("Error fetching videos: {}", e);
                vec![]
            }
        }
    }

    fn get_channel(&self, clientversion: ClientVersion) -> Option<Channel> {
        Some(self.build_channel(clientversion))
    }
}
